/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

/* $Novell-NWU: $Header: /proj6/ncps/nwu_top/nws/include/sys/ncp_app.h,v 1.2 1996/04/05 22:58:13 vtag Exp $ */
/*
 * Copyright 1989, 1991 Novell, Inc. All Rights Reserved.
 *
 * THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
 * TREATIES.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED,
 * COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,
 * CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
 * TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT
 * OF NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT
 * AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO CRIMINAL AND
 * CIVIL LIABILITY.
 *
 */

/*
 *   Users of this file should also include portable.h and ipx_app.h
 *	 Note - portable.h was replaced by sys/nwportable.h for NWU 4.10.
 */

#ifndef __NCP_APP_H__
#define __NCP_APP_H__

#ident "@(#)ncp_app.h	1.2"
#define NCP_SET_MAX_ENGINES 	( ( 'n' << 8 ) | 1 )
#define NCP_SET_MAX_CLIENTS 	( ( 'n' << 8 ) | 2 )
#define NCP_MARK_ENGINE 	 	( ( 'n' << 8 ) | 3 )
#define NCP_UNMARK_ENGINE 	 	( ( 'n' << 8 ) | 4 )
#define NCP_DELETE_CLIENT		( ( 'n' << 8 ) | 5 )
#define NCP_GET_CLIENT_ADDRESS	( ( 'n' << 8 ) | 6 )
#define NCP_SET_SPAWN_AHEAD     ( ( 'n' << 8 ) | 7 )
#define NCP_LOOP				( ( 'n' << 8 ) | 8 )
#define NCP_SET_CLIENTS_PER_ENGINE (('n' << 8 )| 9 )
#define NCP_GET_TABLE_ENTRY		( ( 'n' << 8 ) | 10 )
#define NCP_BAD_PACKET			( ( 'n' << 8 ) | 11 )
#define NCP_QUERY_FREE_CONNECTION		( ( 'n' << 8 ) | 12 )
#define NCP_ADD_BLAST_CONNECTION 	( ( 'n' << 8 ) | 13 )
#define NCP_SET_ENGINE_PID 			( ( 'n' << 8 ) | 14 )
#define NCP_ALLOC_CONNECTION 		( ( 'n' << 8 ) | 15 )
#define NCP_DELETE_IN_PROGRESS		( ( 'n' << 8 ) | 16 )
#define NCP_ADD_CLIENT_COMPLETE		( ( 'n' << 8 ) | 17 )

/*
 * NetWare Core Protocol Packet Structure (NCP)
 * ServiceConnection is the low order byte of the Client Number
 * and Unused is the high order byte.
 */
typedef struct RAWNCP_Header {
	int16	RequestType;			/* High-Low */
	int8	SequenceNumber;
	int8	ServConnLoByte;
	int8	CurrentTask;
	int8	ServConnHiByte;
	int8	Function1;	/* different uses on request/reponse */
	int8	Function2; 	/* not used on requests */	
} RAWNCP;

#define NCPHDRSIZE 7 	/* sizeof aligns unreliably */ 
#define NCP_HDR_SIZE 7 	/* sizeof aligns unreliably */ 
#define NCP_OUT_HDR_SIZE 8 	/* outgoing ncp packet size */ 

typedef struct ncpClientAddr {
	uint16		clientNumber;
	ipxAddr_t	clientAddress;
} ncpClientAddr_t;

#define NCP_CLIENT_ADDR_SIZE	14

#if defined(_KERNEL) || defined(KERNEL)
typedef struct ncpTableEntry {
	ipxAddr_t	addr;
	ipxAddr_t	blastAddr;
	uint32		load;
	uint32		isEngine;
	uint32		enginePid;
	queue_t		*readQ;
	uint32		servicingPacket;
} ncpTableEntry_t;
#endif /* _KERNEL */

typedef struct ncpSetEnginePid {
	uint32		enginePid;
} ncpSetEnginePid_t;

typedef struct ncpAllocConnection {
	uint32		clientNumber;
	uint32		enginePid;
} ncpAllocConnection_t;

#define NCP_TABLE_ENTRY_SIZE	44
#endif
